package com.steerinfo.dil.feign;

import com.steerinfo.framework.controller.RESTfulResult;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/28 13:28
 */

@FeignClient(value = "dil-oms-dev", url = "${openfeign.QMSFeign.url}")
public interface OmsFeign {

     /*
    OmstruckOrderController
     */

    @PostMapping("api/v1/truckTms/omstruckorders/getAllTruckOrder")
    public RESTfulResult getAllTruckOrder(@RequestBody(required=false) Map<String,Object> mapValue,
                                          @RequestParam("apiId") Integer apiId,
                                          @RequestParam("pageNum") Integer pageNum,
                                          @RequestParam("pageSize") Integer pageSize,
                                          @RequestParam("orderStatus") Integer orderStatus,
                                          @RequestParam("planId") Integer planId,
                                          @RequestParam("orderType") Integer orderType);

    @PostMapping("api/v1/truckTms/omstruckorders/getAllTruckOrderReturnListMap")
    public RESTfulResult getAllTruckOrder(
            @RequestParam("orderStatus") Integer orderStatus,
            @RequestParam("planId") Integer planId,
            @RequestParam("orderType") Integer orderType);

    @PostMapping("api/v1/truckTms/omstruckorders/getAllCapacity")
    public RESTfulResult getAllCapacity(@RequestBody(required=false) Map<String,Object> mapValue,
                                        @RequestParam("apiId") Integer apiId,
                                        @RequestParam("pageNum") Integer pageNum,
                                        @RequestParam("pageSize") Integer pageSize,
                                        @RequestParam("carrierId") Integer carrierId);

    @PostMapping("api/v1/truckTms/omstruckorders/addPurOrder")
    public RESTfulResult addPurOrder(@RequestBody(required=false) Map<String,Object> mapValue);

    @PostMapping("api/v1/truckTms/omstruckorders/updateOrder")
    public RESTfulResult updateOrder(@RequestBody Map<String, Object> map);

    @PostMapping("api/v1/truckTms/omstruckorders/dispatchOrder/{orderId}")
    public RESTfulResult dispatchOrder(@PathVariable("orderId") Integer orderId);

    @PostMapping("api/v1/truckTms/omstruckorders/deleteOrder")
    public RESTfulResult deleteOrder(@RequestBody(required = false) Map<String, Object> map,
                                     @RequestParam("planId") Integer planId);

    @PostMapping("api/v1/truckTms/omstruckorders/driverReceiveOrRefuse/{orderId}")
    public RESTfulResult driverReceiveOrRefuse(@PathVariable("orderId") Integer orderId,
                                               @RequestParam("orderReceiveStatus") Integer orderReceiveStatus);

    @PostMapping("api/v1/truckTms/omstruckorders/getReceiveRefuseOrder/{orderReceiveStatus}")
    public RESTfulResult getReceiveRefuseOrder(@RequestBody(required=false) Map<String,Object> mapValue,
                                               @RequestParam("apiId") Integer apiId,
                                               @RequestParam("pageNum") Integer pageNum,
                                               @RequestParam("pageSize") Integer pageSize,
                                               @PathVariable("orderReceiveStatus") Integer orderReceiveStatus,
                                               @RequestParam("orderType") Integer orderType,
                                               @RequestParam("orderStatus") Integer orderStatus);

    @PostMapping("api/v1/truckTms/omstruckorders/sendMesToDriver")
    public RESTfulResult sendMesToDriver(@RequestParam("capacityNumber") String capacityNumber,
                                         @RequestParam("orderStatus") Integer orderStatus);


    @PostMapping("api/v1/truckTms/omstruckorders/getRefuseOrderByCapacityNum")
    public RESTfulResult sendMesToDriver(@RequestParam("capacityNumber") String capacityNumber);


    @PostMapping("api/v1/truckTms/omstruckorders/getOrderMesByOrderNum/{orderId}")
    public RESTfulResult getOrderMesByOrderNum(@PathVariable("orderId") Integer orderId);

    @PostMapping("api/v1/truckTms/omstruckorders/selectPlaceAndTime/{orderId}")
    public RESTfulResult selectPlaceAndTime(@PathVariable("orderId") Integer orderId);

    @PostMapping("api/v1/truckTms/omstruckorders/selectOrderByOrderId/{orderId}")
    public RESTfulResult selectOrderByOrderId(@PathVariable("orderId") Integer orderId);

    @PostMapping("api/v1/truckTms/omstruckorders/getTransportDispatch/{orderReceiveStatus}")
    public RESTfulResult getTransportDispatch(@RequestBody(required=false) Map<String,Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize,
                                              @PathVariable("orderReceiveStatus") Integer orderReceiveStatus,
                                              @RequestParam("orderType") Integer orderType,
                                              @RequestParam("orderStatus") Integer orderStatus);
    /**
     * 展示承运商接收销售公司已接受的销售订单
     * @param carrierId
     * @param apiId
     * @param pageNum
     * @param pageSize
     * @return
     */
    @RequestMapping(value = "api/v1/oms/omstruckorders/getSaleOrderForCarrierList/{carrierId}",method = RequestMethod.POST)
    Map<String,Object> getSaleOrderForCarrierList(@PathVariable("carrierId") Integer carrierId,
                                                  @RequestParam Integer apiId,
                                                  @RequestParam Integer pageNum,
                                                  @RequestParam Integer pageSize);

    /**
     * 查询所有已经接收的焦炭发运日计划
     * @param carrierId
     * @param apiId
     * @param pageNum
     * @param pageSize
     * @return
     */
    @RequestMapping(value = "api/v1/oms/omstruckorders/getCokeDayPlanAndRecivedList",method = RequestMethod.POST)
    Map<String,Object> getCokeDayPlanAndRecivedList(@PathVariable("carrierId") Integer carrierId,
                                                    @RequestParam Integer apiId,
                                                    @RequestParam Integer pageNum,
                                                    @RequestParam Integer pageSize);
    /**
     *查询所有已经接收的水渣发运日计划
     * @param
     * @param pageNum
     * @param pageSize
     * @param apiId
     * @return
     */
    @RequestMapping(value = "api/v1/oms/omstruckorders/getWaterSlagDayPlanAndRecivedList",method = RequestMethod.POST)
    Map<String,Object> getWaterSlagDayPlanAndRecivedList(@PathVariable("carrierId") Integer carrierId,
                                                         @RequestParam Integer apiId,
                                                         @RequestParam Integer pageNum,
                                                         @RequestParam Integer pageSize);
}

